//---
// settings: Adjustment variables for the development process
//---

#pragma once

#include <stdbool.h>
#include "fixed.h"

/* Dimensions of tiles on 1:1, in pixels */
#define TILE_WIDTH 16
#define TILE_HEIGHT 16
/* Height of walls on 1:1, in pixels (a fraction of TILE_HEIGHT) */
#define WALL_HEIGHT 10
/* Minimum and maximum zoom levels */
#define ZOOM_MIN 1
#define ZOOM_MAX 3
/* Number of empty tiles around the map that can be viewed (extra scroll) */
#define CAMERA_BORDER 2
/* Lock the camera at the center of the map when using zoom x1 */
#define CAMERA_LOCK_AT_x1 false
/* Camera speed in tiles per second (should be in ratio inversely proportional
   to TILE_WIDTH and TILE_HEIGHT to keep same speed on both axis on screen) */
#define CAMERA_SPEED_X fix(3)
#define CAMERA_SPEED_Y fix(3)
/* Ideal frame rate (FPS) */
#define FRAME_RATE 30
/* Knockback speed when entities are hit */
#define KNOCKBACK_SPEED fix(15)
