//---
// skills: Utilities that characterize and run skills
//---

#pragma once

#include "game.h"
#include "comp/entity.h"

enum {
    SKILL_DASH = 0x100,
    SKILL_SPEED,

    /* Other skills in the AOE enumeration that are valid here: */
    // AOE_PROJECTILE,
    // AOE_PROJECTILE_FAST,
    // AOE_SHOCK,
    // AOE_JUDGEMENT,
    // AOE_BULLET,
    // AOE_FIRE_CHARGE,
    // AOE_WATER_CHARGE,
    // AOE_CHEMICAL_CHARGE,
};

/* Fixed cooldown for a skill */
fixed_t skill_cooldown(int skill);

/* Have [e] use its skill in the specified slot. Returns true on success. */
bool skill_use(game_t *g, entity_t *e, int slot, vec2 dir);

/* Render a skill's image */
void skill_render(int x, int y, int skill, int bg, int color);

/* Reference to a skill's image */
bool skill_render_get(int skill, image_t **img, int *left, int *top);
